﻿using UnityEngine;
using HarmonyLib;
using System;

public class FriendlySprinkler : Mod
{
    public void Start()
    {

        this.initFriendlySprinkler();

        Debug.Log("Mod Friendly Sprinkler has been loaded!");
    }

    public void Update()
    {
        this.initFriendlySprinkler();
    }

    public override void WorldEvent_WorldLoaded()
    {
        this.initFriendlySprinkler();
    }

    public void OnModUnload()
    {

        if (RAPI.GetLocalPlayer() != null)
        {

            Sprinkler purifier = FindObjectOfType<Sprinkler>();
            object batteryUsesPerPlotNorm = Traverse.Create(purifier).Field("batteryUsesPerPlot").GetValue() as object;

            object batteryUsesPerPlotValue = Traverse.Create(purifier).Field("batteryUsesPerPlot").SetValue(batteryUsesPerPlotNorm);
            Debug.Log("battery Uses Per Plot: " + batteryUsesPerPlotValue);
        }

        Destroy(gameObject);
        Debug.Log("Mod Friendly Sprinkler has been unloaded!");
    }

    public void initFriendlySprinkler()
    {
        if (RAPI.GetLocalPlayer() != null)
        {
            Sprinkler purifier = FindObjectOfType<Sprinkler>();
            object batteryUsesPerPlotNorm = Traverse.Create(purifier).Field("batteryUsesPerPlot").GetValue() as object;

            if (Convert.ToInt32(batteryUsesPerPlotNorm) > 0)
            {
                object batteryUsesPerPlotValue = Traverse.Create(purifier).Field("batteryUsesPerPlot").SetValue(0);
                Debug.Log("battery Uses Per Plot: " + batteryUsesPerPlotValue);
            }
        }
    }
}